/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   pushswap.h                                         :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: cchauvet <cchauvet@student.42angouleme.fr  +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2022/11/08 18:19:44 by cchauvet          #+#    #+#             */
/*   Updated: 2022/12/11 17:55:38 by cchauvet         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#ifndef PUSHSWAP_H
# define PUSHSWAP_H
# include <unistd.h>
# include <stdlib.h>
# include <limits.h>
# define STOP_VALUE 4294967295

int				ft_isnum(char *str);
size_t			ft_strlen(const char *s);
long int		ft_atoi(char *str);
void			ft_putstr(char *str);
size_t			ft_seglen(const char *s, char c);
char			**ft_split(const char *s, char c);
void			ft_cancel(char **str, size_t len);

void			ft_sort(long int *tab, int size);

int				ft_get_max_index(long int *tab, int size);

int				ft_get_max(unsigned int *tab);
int				ft_tablen(unsigned int *tab);
int				ft_is_sorted(unsigned int *in);
unsigned int	ft_bitlen(unsigned int nb);

void			ft_radix_sort(unsigned int *tab_a, unsigned int *tab_b);
void			ft_bozo_sort(unsigned int *tab_a, unsigned int *tab_b);
void			ft_swap(unsigned int *a, unsigned int *b);
void			ft_pa(unsigned int *tab_a, unsigned int *tab_b);
void			ft_pb(unsigned int *tab_a, unsigned int *tab_b);
void			ft_ra(unsigned int *tab_a);
void			ft_rb(unsigned int *tab_b);
void			ft_rra(unsigned int *tab_a);
void			ft_rrb(unsigned int *tab_b);
void			ft_sa(unsigned int *tab_a);

typedef unsigned int	*t_tab;
#endif
